/******************************************************************************
 * Filename: debug.h
 * Description:
 *
 * Version: 1.0
 * Created: Sep 12 2011 09:58:17
 * Last modified: Sep 12 2011 09:58:17
 *
 * Author: Ladislav Láska
 * e-mail: ladislav.laska@gmail.com
 *
 ******************************************************************************/
#ifndef _CORE_DEBUG_H_
#define _CORE_DEBUG_H_

#ifdef DEBUG
#include <stdio.h>
#define DBG_STREAM stderr
#define debug(msg) fprintf(DBG_STREAM, "(Debug): %s\n", msg)
#define debugf(fmt,...) fprintf(DBG_STREAM, "(Debug): " fmt "\n", __VA_ARGS__)
#else
#define debug(msg) ;
#define debugf(fmt,...) ;
#endif

#define warn(msg) fprintf(DBG_STREAM, "(Warning): %s\n", msg)
#define warnf(fmt,...) fprintf(DBG_STREAM, "(Warning): " fmt "\n", __VA_ARGS__)

int char_to_binary(unsigned char c);


#endif
