/******************************************************************************
 * Filename: serializer.h
 *
 * Created: 2012/04/30 23:13
 * Author: Ladislav Láska
 * e-mail: laska@kam.mff.cuni.cz
 *
 ******************************************************************************/

#ifndef __CORE_SERIALIZER_H__
#define __CORE_SERIALIZER_H__

#include "../core.h"

/* struct seri_data is defined in program.h */

int idis_seri_init(struct program *prg,char *filename);
int idis_seri_fini();
void idis_seri_mapping_start();
void idis_seri_mapping_end();
void idis_seri_scalar(char *val);
void idis_seri_mapping_item(char *key, char *value);


/* Function to deserialize program. */
struct program *idis_deser( char *str );
PyObject *idis_deser_hash( struct seri_data *d );
PyObject *idis_deser_list( struct seri_data *d );
PyObject *idis_deser_module( struct seri_data *d, char *modname );

#endif
