/******************************************************************************
 * Filename: symbol.h
 *
 * Created: 2011/11/26 13:20
 * Author: Ladislav Láska
 * e-mail: laska@kam.mff.cuni.cz
 *
 ******************************************************************************/

#ifndef __SYMBOL_H__
#define __SYMBOL_H__

#include <stddef.h>

#include "program.h"

struct symbol *idis_lookup_symbol( struct program *prg, size_t addr );
struct symbol *idis_lookup_symbol_by_addr( struct program *prg, size_t addr );
struct symbol *idis_lookup_symbol_nearest( struct program *prg, size_t addr );
struct symbol *idis_lookup_symbol_by_name( struct program *prg, char *name );
void idis_finalize_symbols( struct program *prg );

struct symbol *idis_add_symbol( struct program *prg );

char *idis_strsym( struct symbol *sym );
char *idis_strsym_rel( struct symbol *sym, vmaddr_t relto );

#endif
