/******************************************************************************
 * Filename: util.c
 *
 * Created: 2012/04/11 21:44
 * Author: Ladislav Láska
 * e-mail: laska@kam.mff.cuni.cz
 *
 ******************************************************************************/

#include "util.h"

void gidis_util_invert(cairo_t *cr, int x1, int y1, int x2, int y2) {
	gidis_util_invert_color(cr, x1, y1, x2, y2, 1, 1, 1);
}

void gidis_util_operator(cairo_t *cr, int x1, int y1, int x2, int y2, double r, double g, double b, int op) {
	double x,y;
	cairo_get_current_point(cr, &x, &y);
	cairo_save(cr);
	cairo_set_source_rgb(cr, r, g, b);
	cairo_set_operator(cr, op);
	cairo_rectangle(cr, x1, y1, x2-x1, y2-y1);
	cairo_fill(cr);
	cairo_restore(cr);
	cairo_move_to(cr, x, y);
}

void gidis_util_invert_color(cairo_t *cr, int x1, int y1, int x2, int y2, double r, double g, double b) {
	gidis_util_operator(cr, x1, y1, x2, y2, r, g, b, CAIRO_OPERATOR_DIFFERENCE);
}

void gidis_util_add_color(cairo_t *cr, int x1, int y1, int x2, int y2, double r, double g, double b) {
	gidis_util_operator(cr, x1, y1, x2, y2, r, g, b, CAIRO_OPERATOR_ADD);
}

void gidis_util_fill_color(cairo_t *cr, int x1, int y1, int x2, int y2, double r, double g, double b) {
	gidis_util_operator(cr, x1, y1, x2, y2, r, g, b, CAIRO_OPERATOR_SOURCE);
}
