import idis
import regval

def bblock_hook(prg, bblock):
	if bblock.lasti.mnem == "call":
		args = [];
		for reg in [idis.R_RDI, idis.R_RSI, idis.R_RDX, idis.R_RCX, idis.R_R8, idis.R_R9]:
			exval = regval.valueof(prg, bblock, reg);
			args.append(exval);
	
		s = []
		for arg in reversed(args):
			if (s == [] and arg == None): continue;
			s.insert(0,str(arg));
		sym = idis.instr_branch_symbol(prg, bblock.lasti);
		syms = "call"
		if sym != None: syms = sym.name;
		bblock.lasti.add_comment("%(fn)s(%(args)s)" % dict(fn=syms,args=', '.join(s)));
