import idis, gidis

data = {};

def init_hook():
	gidis.add_command_hook( "comment", command_hook );
	gidis.add_hotkey_hook( "c", hotkey_hook );

def hotkey_hook( prg, instr ):
	txt = "";
	global data;
	if instr.vmaddr in data:
		txt = data[instr.vmaddr];
	gidis.editor_start_text( ":comment %s" % txt );

def command_hook( prg, instr, args ):
	global data;
	if args == "":
		del data[instr.vmaddr];
	else:
		data[instr.vmaddr] = args;
	gidis.rebuild_linebuf();
	

def instr_hook(prg, sec, instr):
	instr.add_annotate_hook( comment_hook, None );

def comment_hook(prg, instr, vmaddr):
	global data;
	if instr.vmaddr in data:
		return data[instr.vmaddr];
	else: 
		return None;

def serialize_hook(prg):
	global data;
	idis.serialize(data);

def deserialize_hook(prg, d):
	global data;
	for key in d["data"]:
		data[int(key)] = d["data"][key];
