import idis, gidis
import regval

def mnem2op(mnem):
	if (mnem in ["je", "jz"]): return "==";
	elif (mnem in ["jne", "jnz"]): return "!=";
	elif (mnem in ["jl", "jnge"]): return "<";
	elif (mnem in ["jge", "jnl"]): return ">=";
	elif (mnem in ["jle", "jng"]): return "<=";
	elif (mnem in ["jg", "jnle"]): return ">";
	return None;

def annotate_hook(prg, instr, data):
	#compi = data["compi"];
	#return "if (%(a)s %(op)s %(b)s)" % dict( a=gidis.strop(compi, compi.ops[0]), b=gidis.strop(compi, compi.ops[1]), op=data["op"] );
	return "if (%(a)s %(op)s %(b)s)" % dict( a=gidis.strexpr(data["op1"]), b=gidis.strexpr(data["op2"]), op=data["op"] );

def bblock_hook(prg, bblock):
	if bblock.lasti._def.flags & idis.IDF_CONDITIONAL and bblock.instrn-2 >= 0:
		compi = bblock.instrs[bblock.instrn-2];
		if compi != None and compi.mnem == "cmp":
			op = mnem2op(bblock.lasti.mnem);
			if op != None:
				# If registers are used, try to get their value.
				op1 = None;
				op2 = None;
				if compi.ops[0].type == idis.OT_REG:
					op1 = regval.valueof(prg, bblock, compi.ops[0].val);
				if compi.ops[1].type == idis.OT_REG:
					op1 = regval.valueof(prg, bblock, compi.ops[1].val);
				if op1 == None: op1 = compi.ops[0].expr;
				if op2 == None: op2 = compi.ops[1].expr;
				bblock.lasti.add_annotate_hook(annotate_hook, {"instr":bblock.lasti, "compi":compi, "op":op, "op1":op1, "op2":op2} );
