/******************************************************************************
 * Filename: instr_data.h
 *
 * Created: 2011/10/16 21:55
 * Author: Ladislav Láska
 * e-mail: laska@kam.mff.cuni.cz
 *
 ******************************************************************************/

#ifndef __INSTR_DATA_H__
#define __INSTR_DATA_H__

#include <string.h>

#define NO_EXT 8

enum {
	A_NULL = 0,
	A_def = 1,
	A_E = 2, /* ModR/M specifies operand */
	A_G = 3, /* Reg field in ModR/M specifies GPR */
	A_H = 4,
	A_A = 5,
	A_C = 6,
	A_D = 7,
	A_ES = 8,
	A_EST = 9,
	A_I = 10,
	A_J = 11,
	A_M = 12,
	A_O = 13,
	A_R = 14,
	A_S = 15,
	A_Z = 16,
	A_REG = 17,
	__A_LAST
};

enum {
	T_1 = 1,
	T_b = 2,	/* Byte */
	T_bcd = 3,	/* TODO: Packed BCD */
	T_bs = 4,	/* Byte, sign extended */
	T_bss = 5,  /* Byte, sign extended to stack pointer (? PUSH 6A only) */
	T_d = 6,
	T_def = 7,
	T_di = 8,
	T_dqp = 9,
	T_dr = 10,
	T_e = 11,
	T_er = 12,
	T_p = 13,
	T_ptp = 14,
	T_q = 15,
	T_qi = 16,
	T_s = 17,
	T_sr = 18,
	T_st = 19,
	T_stx = 20,
	T_v = 21,
	T_vds = 22,
	T_vq = 23,
	T_vqp = 24,
	T_vs = 25,
	T_w = 26,
	T_wi = 27,
	T_pi = 28,
	T_dq = 29,
	T_a = 30,
	T_qp = 31,
	T_wo = 32,
	T_do = 33,
	T_dqa = 34,
	T_da = 35,
	T_qa = 36,
	T_CONST = 37,
	T_STACK = 38,
	__T_LAST
};

enum {
	OF_DEST = 1,
	OF_HIDDEN = 2,
	OF_VDEST = 4
};

enum {
	IDF_8BIT = 1,
	IDF_16BIT = 2,
	IDF_64BIT = 4,
	IDF_BRANCH = 8,
	IDF_CONDITIONAL = 16,
	IDF_JUMP_NEAR = 32,
	IDF_JUMP_FAR = 64
};


typedef struct op_def {
	unsigned char addr;
	unsigned char type;
	unsigned char def;
	unsigned char flags;
} _op_def_t;

typedef struct instr_def {
	char *mnem;
	char *desc;
	unsigned char prefix;
	unsigned char x0f;
	unsigned char opcd;
	unsigned char opcd2;
	unsigned char mask;
	unsigned char extension;
	unsigned int flags;
	struct op_def **ops;	/* Null terminated list of operands */
} _instr_def_t;

#endif
